"""


No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations

import json
import pprint
from typing import Any, Dict, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, ValidationError, field_validator
from typing_extensions import Self

from annofabapi.pydantic_models.annotation_specs_v1 import AnnotationSpecsV1
from annofabapi.pydantic_models.annotation_specs_v2 import AnnotationSpecsV2
from annofabapi.pydantic_models.annotation_specs_v3 import AnnotationSpecsV3

ANNOTATIONSPECS_ONE_OF_SCHEMAS = ["AnnotationSpecsV1", "AnnotationSpecsV2", "AnnotationSpecsV3"]


class AnnotationSpecs(BaseModel):
    """
    AnnotationSpecs
    """

    # data type: AnnotationSpecsV1
    oneof_schema_1_validator: Optional[AnnotationSpecsV1] = None
    # data type: AnnotationSpecsV2
    oneof_schema_2_validator: Optional[AnnotationSpecsV2] = None
    # data type: AnnotationSpecsV3
    oneof_schema_3_validator: Optional[AnnotationSpecsV3] = None
    actual_instance: Optional[Union[AnnotationSpecsV1, AnnotationSpecsV2, AnnotationSpecsV3]] = None
    one_of_schemas: Set[str] = {"AnnotationSpecsV1", "AnnotationSpecsV2", "AnnotationSpecsV3"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = AnnotationSpecs.model_construct()
        error_messages = []
        match = 0
        # validate data type: AnnotationSpecsV1
        if not isinstance(v, AnnotationSpecsV1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AnnotationSpecsV1`")
        else:
            match += 1
        # validate data type: AnnotationSpecsV2
        if not isinstance(v, AnnotationSpecsV2):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AnnotationSpecsV2`")
        else:
            match += 1
        # validate data type: AnnotationSpecsV3
        if not isinstance(v, AnnotationSpecsV3):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AnnotationSpecsV3`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in AnnotationSpecs with oneOf schemas: AnnotationSpecsV1, AnnotationSpecsV2, AnnotationSpecsV3. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in AnnotationSpecs with oneOf schemas: AnnotationSpecsV1, AnnotationSpecsV2, AnnotationSpecsV3. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AnnotationSpecsV1
        try:
            instance.actual_instance = AnnotationSpecsV1.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AnnotationSpecsV2
        try:
            instance.actual_instance = AnnotationSpecsV2.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AnnotationSpecsV3
        try:
            instance.actual_instance = AnnotationSpecsV3.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into AnnotationSpecs with oneOf schemas: AnnotationSpecsV1, AnnotationSpecsV2, AnnotationSpecsV3. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into AnnotationSpecs with oneOf schemas: AnnotationSpecsV1, AnnotationSpecsV2, AnnotationSpecsV3. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AnnotationSpecsV1, AnnotationSpecsV2, AnnotationSpecsV3]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
