"""


No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing_extensions import Self

from annofabapi.pydantic_models.annotation_specs_option import AnnotationSpecsOption
from annofabapi.pydantic_models.inspection_phrase import InspectionPhrase
from annofabapi.pydantic_models.label_v1 import LabelV1


class AnnotationSpecsV1(BaseModel):
    """
    AnnotationSpecsV1
    """

    project_id: StrictStr = Field(description="プロジェクトID。[値の制約についてはこちら。](#section/API-Convention/APIID) ")
    labels: List[LabelV1] = Field(description="ラベル")
    inspection_phrases: List[InspectionPhrase] = Field(description="定型指摘")
    updated_datetime: Optional[str] = Field(default=None, description="更新日時 ")
    option: Optional[AnnotationSpecsOption] = None
    metadata: Dict[str, StrictStr] = Field(description="ユーザーが自由に登録できるkey-value型のメタデータです。 ")
    __properties: ClassVar[List[str]] = ["project_id", "labels", "inspection_phrases", "updated_datetime", "option", "metadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AnnotationSpecsV1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in labels (list)
        _items = []
        if self.labels:
            for _item_labels in self.labels:
                if _item_labels:
                    _items.append(_item_labels.to_dict())
            _dict["labels"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in inspection_phrases (list)
        _items = []
        if self.inspection_phrases:
            for _item_inspection_phrases in self.inspection_phrases:
                if _item_inspection_phrases:
                    _items.append(_item_inspection_phrases.to_dict())
            _dict["inspection_phrases"] = _items
        # override the default output from pydantic by calling `to_dict()` of option
        if self.option:
            _dict["option"] = self.option.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AnnotationSpecsV1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "project_id": obj.get("project_id"),
                "labels": [LabelV1.from_dict(_item) for _item in obj["labels"]] if obj.get("labels") is not None else None,
                "inspection_phrases": [InspectionPhrase.from_dict(_item) for _item in obj["inspection_phrases"]]
                if obj.get("inspection_phrases") is not None
                else None,
                "updated_datetime": obj.get("updated_datetime"),
                "option": AnnotationSpecsOption.from_dict(obj["option"]) if obj.get("option") is not None else None,
                "metadata": obj.get("metadata"),
            }
        )
        return _obj
