"""


No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations

import json
import pprint
from typing import Any, Dict, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, ValidationError, field_validator
from typing_extensions import Self

from annofabapi.pydantic_models.global_idp_name_determinant import GlobalIdpNameDeterminant
from annofabapi.pydantic_models.organization_idp_id_determinant import OrganizationIdpIdDeterminant
from annofabapi.pydantic_models.user_id_determinant import UserIdDeterminant

EXTERNALIDPDETERMINANT_ONE_OF_SCHEMAS = ["GlobalIdpNameDeterminant", "OrganizationIdpIdDeterminant", "UserIdDeterminant"]


class ExternalIdpDeterminant(BaseModel):
    """
    ExternalIdpDeterminant
    """

    # data type: GlobalIdpNameDeterminant
    oneof_schema_1_validator: Optional[GlobalIdpNameDeterminant] = None
    # data type: OrganizationIdpIdDeterminant
    oneof_schema_2_validator: Optional[OrganizationIdpIdDeterminant] = None
    # data type: UserIdDeterminant
    oneof_schema_3_validator: Optional[UserIdDeterminant] = None
    actual_instance: Optional[Union[GlobalIdpNameDeterminant, OrganizationIdpIdDeterminant, UserIdDeterminant]] = None
    one_of_schemas: Set[str] = {"GlobalIdpNameDeterminant", "OrganizationIdpIdDeterminant", "UserIdDeterminant"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = ExternalIdpDeterminant.model_construct()
        error_messages = []
        match = 0
        # validate data type: GlobalIdpNameDeterminant
        if not isinstance(v, GlobalIdpNameDeterminant):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GlobalIdpNameDeterminant`")
        else:
            match += 1
        # validate data type: OrganizationIdpIdDeterminant
        if not isinstance(v, OrganizationIdpIdDeterminant):
            error_messages.append(f"Error! Input type `{type(v)}` is not `OrganizationIdpIdDeterminant`")
        else:
            match += 1
        # validate data type: UserIdDeterminant
        if not isinstance(v, UserIdDeterminant):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UserIdDeterminant`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in ExternalIdpDeterminant with oneOf schemas: GlobalIdpNameDeterminant, OrganizationIdpIdDeterminant, UserIdDeterminant. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in ExternalIdpDeterminant with oneOf schemas: GlobalIdpNameDeterminant, OrganizationIdpIdDeterminant, UserIdDeterminant. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into GlobalIdpNameDeterminant
        try:
            instance.actual_instance = GlobalIdpNameDeterminant.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into OrganizationIdpIdDeterminant
        try:
            instance.actual_instance = OrganizationIdpIdDeterminant.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UserIdDeterminant
        try:
            instance.actual_instance = UserIdDeterminant.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into ExternalIdpDeterminant with oneOf schemas: GlobalIdpNameDeterminant, OrganizationIdpIdDeterminant, UserIdDeterminant. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into ExternalIdpDeterminant with oneOf schemas: GlobalIdpNameDeterminant, OrganizationIdpIdDeterminant, UserIdDeterminant. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], GlobalIdpNameDeterminant, OrganizationIdpIdDeterminant, UserIdDeterminant]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
