"""


No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations

import json
import pprint
from typing import Any, Dict, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, ValidationError, field_validator
from typing_extensions import Self

from annofabapi.pydantic_models.action_required import ActionRequired
from annofabapi.pydantic_models.illegal_state import IllegalState
from annofabapi.pydantic_models.inspection_or_reply_required import InspectionOrReplyRequired
from annofabapi.pydantic_models.no_comment_inspection import NoCommentInspection
from annofabapi.pydantic_models.reply_required import ReplyRequired

INSPECTIONVALIDATIONERROR_ONE_OF_SCHEMAS = ["ActionRequired", "IllegalState", "InspectionOrReplyRequired", "NoCommentInspection", "ReplyRequired"]


class InspectionValidationError(BaseModel):
    """
    InspectionValidationError
    """

    # data type: NoCommentInspection
    oneof_schema_1_validator: Optional[NoCommentInspection] = None
    # data type: ReplyRequired
    oneof_schema_2_validator: Optional[ReplyRequired] = None
    # data type: ActionRequired
    oneof_schema_3_validator: Optional[ActionRequired] = None
    # data type: InspectionOrReplyRequired
    oneof_schema_4_validator: Optional[InspectionOrReplyRequired] = None
    # data type: IllegalState
    oneof_schema_5_validator: Optional[IllegalState] = None
    actual_instance: Optional[Union[ActionRequired, IllegalState, InspectionOrReplyRequired, NoCommentInspection, ReplyRequired]] = None
    one_of_schemas: Set[str] = {"ActionRequired", "IllegalState", "InspectionOrReplyRequired", "NoCommentInspection", "ReplyRequired"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = InspectionValidationError.model_construct()
        error_messages = []
        match = 0
        # validate data type: NoCommentInspection
        if not isinstance(v, NoCommentInspection):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NoCommentInspection`")
        else:
            match += 1
        # validate data type: ReplyRequired
        if not isinstance(v, ReplyRequired):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReplyRequired`")
        else:
            match += 1
        # validate data type: ActionRequired
        if not isinstance(v, ActionRequired):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ActionRequired`")
        else:
            match += 1
        # validate data type: InspectionOrReplyRequired
        if not isinstance(v, InspectionOrReplyRequired):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InspectionOrReplyRequired`")
        else:
            match += 1
        # validate data type: IllegalState
        if not isinstance(v, IllegalState):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IllegalState`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in InspectionValidationError with oneOf schemas: ActionRequired, IllegalState, InspectionOrReplyRequired, NoCommentInspection, ReplyRequired. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in InspectionValidationError with oneOf schemas: ActionRequired, IllegalState, InspectionOrReplyRequired, NoCommentInspection, ReplyRequired. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into NoCommentInspection
        try:
            instance.actual_instance = NoCommentInspection.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ReplyRequired
        try:
            instance.actual_instance = ReplyRequired.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ActionRequired
        try:
            instance.actual_instance = ActionRequired.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into InspectionOrReplyRequired
        try:
            instance.actual_instance = InspectionOrReplyRequired.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into IllegalState
        try:
            instance.actual_instance = IllegalState.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into InspectionValidationError with oneOf schemas: ActionRequired, IllegalState, InspectionOrReplyRequired, NoCommentInspection, ReplyRequired. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into InspectionValidationError with oneOf schemas: ActionRequired, IllegalState, InspectionOrReplyRequired, NoCommentInspection, ReplyRequired. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ActionRequired, IllegalState, InspectionOrReplyRequired, NoCommentInspection, ReplyRequired]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
