"""


No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing_extensions import Self

from annofabapi.pydantic_models.my_notification_message import MyNotificationMessage


class MyNotificationList(BaseModel):
    """
    自分に届いているユーザー通知の取得結果です。
    """

    messages: List[MyNotificationMessage]
    opened: StrictInt = Field(
        description="開封済みの通知メッセージの数。 over_limitがtrueの場合、メッセージのタイムスタンプが新しい順から10000件のメッセージをもとに集計される "
    )
    total: StrictInt = Field(description="通知メッセージの総数 ")
    page: StrictInt = Field(description="messagesに含まれる通知メッセージが何ページ目のものか ")
    page_total: StrictInt = Field(description="ページ数の総数 ")
    over_limit: StrictBool = Field(description="通知メッセージの取得上限を超えているか ")
    __properties: ClassVar[List[str]] = ["messages", "opened", "total", "page", "page_total", "over_limit"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MyNotificationList from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in messages (list)
        _items = []
        if self.messages:
            for _item_messages in self.messages:
                if _item_messages:
                    _items.append(_item_messages.to_dict())
            _dict["messages"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MyNotificationList from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "messages": [MyNotificationMessage.from_dict(_item) for _item in obj["messages"]] if obj.get("messages") is not None else None,
                "opened": obj.get("opened"),
                "total": obj.get("total"),
                "page": obj.get("page"),
                "page_total": obj.get("page_total"),
                "over_limit": obj.get("over_limit"),
            }
        )
        return _obj
