"""


No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations

import json
import pprint
from typing import Any, Dict, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, ValidationError, field_validator
from typing_extensions import Self

from annofabapi.pydantic_models.plugin_detail_annotation_editor import PluginDetailAnnotationEditor
from annofabapi.pydantic_models.plugin_detail_annotation_specs import PluginDetailAnnotationSpecs
from annofabapi.pydantic_models.plugin_detail_extended_annotation_specs import PluginDetailExtendedAnnotationSpecs
from annofabapi.pydantic_models.plugin_detail_task_assignment import PluginDetailTaskAssignment

PLUGINDETAIL_ONE_OF_SCHEMAS = [
    "PluginDetailAnnotationEditor",
    "PluginDetailAnnotationSpecs",
    "PluginDetailExtendedAnnotationSpecs",
    "PluginDetailTaskAssignment",
]


class PluginDetail(BaseModel):
    """
    * `PluginDetailAnnotationEditor` - カスタムアノテーションエディタ用のプラグインを表します。 * `PluginDetailTaskAssignment` - カスタムタスク割当用のプラグインを表します。 * `PluginDetailAnnotationSpecs` - カスタムアノテーション仕様用のプラグインを表します。 * `PluginDetailExtendedAnnotationSpecs` - カスタムのアノテーション種別を作成するプラグインを表します。
    """

    # data type: PluginDetailAnnotationEditor
    oneof_schema_1_validator: Optional[PluginDetailAnnotationEditor] = None
    # data type: PluginDetailTaskAssignment
    oneof_schema_2_validator: Optional[PluginDetailTaskAssignment] = None
    # data type: PluginDetailAnnotationSpecs
    oneof_schema_3_validator: Optional[PluginDetailAnnotationSpecs] = None
    # data type: PluginDetailExtendedAnnotationSpecs
    oneof_schema_4_validator: Optional[PluginDetailExtendedAnnotationSpecs] = None
    actual_instance: Optional[
        Union[PluginDetailAnnotationEditor, PluginDetailAnnotationSpecs, PluginDetailExtendedAnnotationSpecs, PluginDetailTaskAssignment]
    ] = None
    one_of_schemas: Set[str] = {
        "PluginDetailAnnotationEditor",
        "PluginDetailAnnotationSpecs",
        "PluginDetailExtendedAnnotationSpecs",
        "PluginDetailTaskAssignment",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = PluginDetail.model_construct()
        error_messages = []
        match = 0
        # validate data type: PluginDetailAnnotationEditor
        if not isinstance(v, PluginDetailAnnotationEditor):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PluginDetailAnnotationEditor`")
        else:
            match += 1
        # validate data type: PluginDetailTaskAssignment
        if not isinstance(v, PluginDetailTaskAssignment):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PluginDetailTaskAssignment`")
        else:
            match += 1
        # validate data type: PluginDetailAnnotationSpecs
        if not isinstance(v, PluginDetailAnnotationSpecs):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PluginDetailAnnotationSpecs`")
        else:
            match += 1
        # validate data type: PluginDetailExtendedAnnotationSpecs
        if not isinstance(v, PluginDetailExtendedAnnotationSpecs):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PluginDetailExtendedAnnotationSpecs`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in PluginDetail with oneOf schemas: PluginDetailAnnotationEditor, PluginDetailAnnotationSpecs, PluginDetailExtendedAnnotationSpecs, PluginDetailTaskAssignment. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in PluginDetail with oneOf schemas: PluginDetailAnnotationEditor, PluginDetailAnnotationSpecs, PluginDetailExtendedAnnotationSpecs, PluginDetailTaskAssignment. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into PluginDetailAnnotationEditor
        try:
            instance.actual_instance = PluginDetailAnnotationEditor.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PluginDetailTaskAssignment
        try:
            instance.actual_instance = PluginDetailTaskAssignment.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PluginDetailAnnotationSpecs
        try:
            instance.actual_instance = PluginDetailAnnotationSpecs.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PluginDetailExtendedAnnotationSpecs
        try:
            instance.actual_instance = PluginDetailExtendedAnnotationSpecs.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into PluginDetail with oneOf schemas: PluginDetailAnnotationEditor, PluginDetailAnnotationSpecs, PluginDetailExtendedAnnotationSpecs, PluginDetailTaskAssignment. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into PluginDetail with oneOf schemas: PluginDetailAnnotationEditor, PluginDetailAnnotationSpecs, PluginDetailExtendedAnnotationSpecs, PluginDetailTaskAssignment. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[
            Dict[str, Any], PluginDetailAnnotationEditor, PluginDetailAnnotationSpecs, PluginDetailExtendedAnnotationSpecs, PluginDetailTaskAssignment
        ]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
