"""


No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations

import json
import pprint
from typing import Any, Dict, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, ValidationError, field_validator
from typing_extensions import Self

from annofabapi.pydantic_models.task_assign_request_type_random import TaskAssignRequestTypeRandom
from annofabapi.pydantic_models.task_assign_request_type_selection import TaskAssignRequestTypeSelection
from annofabapi.pydantic_models.task_assign_request_type_task_property import TaskAssignRequestTypeTaskProperty

TASKASSIGNREQUESTTYPE_ONE_OF_SCHEMAS = ["TaskAssignRequestTypeRandom", "TaskAssignRequestTypeSelection", "TaskAssignRequestTypeTaskProperty"]


class TaskAssignRequestType(BaseModel):
    """
    * `TaskAssignRequestTypeRandom`: 自分自身にランダムにタスクを割り当てます。プロジェクト設定でタスクのランダム割当を有効にした場合のみ利用できます。 * `TaskAssignRequestTypeSelection`: メンバーに指定したタスクを割り当てます。ただし、メンバーはプロジェクトオーナーもしくはチェッカーロールを持つ必要があります。プロジェクト設定でタスクの選択割当を有効にした場合のみ利用できます。 * `TaskAssignRequestTypeTaskProperty`: タスクプロパティ割当の設定に基づいて、タスクを自分自身に割り当てます。プロジェクト設定でタスクプロパティ割当を有効にした場合のみ利用できます。
    """

    # data type: TaskAssignRequestTypeRandom
    oneof_schema_1_validator: Optional[TaskAssignRequestTypeRandom] = None
    # data type: TaskAssignRequestTypeSelection
    oneof_schema_2_validator: Optional[TaskAssignRequestTypeSelection] = None
    # data type: TaskAssignRequestTypeTaskProperty
    oneof_schema_3_validator: Optional[TaskAssignRequestTypeTaskProperty] = None
    actual_instance: Optional[Union[TaskAssignRequestTypeRandom, TaskAssignRequestTypeSelection, TaskAssignRequestTypeTaskProperty]] = None
    one_of_schemas: Set[str] = {"TaskAssignRequestTypeRandom", "TaskAssignRequestTypeSelection", "TaskAssignRequestTypeTaskProperty"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = TaskAssignRequestType.model_construct()
        error_messages = []
        match = 0
        # validate data type: TaskAssignRequestTypeRandom
        if not isinstance(v, TaskAssignRequestTypeRandom):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TaskAssignRequestTypeRandom`")
        else:
            match += 1
        # validate data type: TaskAssignRequestTypeSelection
        if not isinstance(v, TaskAssignRequestTypeSelection):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TaskAssignRequestTypeSelection`")
        else:
            match += 1
        # validate data type: TaskAssignRequestTypeTaskProperty
        if not isinstance(v, TaskAssignRequestTypeTaskProperty):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TaskAssignRequestTypeTaskProperty`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in TaskAssignRequestType with oneOf schemas: TaskAssignRequestTypeRandom, TaskAssignRequestTypeSelection, TaskAssignRequestTypeTaskProperty. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in TaskAssignRequestType with oneOf schemas: TaskAssignRequestTypeRandom, TaskAssignRequestTypeSelection, TaskAssignRequestTypeTaskProperty. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into TaskAssignRequestTypeRandom
        try:
            instance.actual_instance = TaskAssignRequestTypeRandom.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TaskAssignRequestTypeSelection
        try:
            instance.actual_instance = TaskAssignRequestTypeSelection.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TaskAssignRequestTypeTaskProperty
        try:
            instance.actual_instance = TaskAssignRequestTypeTaskProperty.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into TaskAssignRequestType with oneOf schemas: TaskAssignRequestTypeRandom, TaskAssignRequestTypeSelection, TaskAssignRequestTypeTaskProperty. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into TaskAssignRequestType with oneOf schemas: TaskAssignRequestTypeRandom, TaskAssignRequestTypeSelection, TaskAssignRequestTypeTaskProperty. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[Union[Dict[str, Any], TaskAssignRequestTypeRandom, TaskAssignRequestTypeSelection, TaskAssignRequestTypeTaskProperty]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
